# A copier et à coller dans quick-pi
# Version 4 étoiles du programme : Sommeil agréable
# Objet(s) : thermomètre, led, microphone, capteur lumière
# ------------------------------------------------------------
# Problème
# Écrivez un programme qui toutes les 50ms, allume la LED verte si :
# la température est entre 16 et 18 degrés inclus
# - la luminosité est inférieure ou égale à 10%
# - le volume de bruit est inférieur ou égal à 20
# Il doit allumer la LED bleue si deux des trois critères sont validés,
# et la LED rouge si un seul ou aucun ne l'est.
# Votre programme ne peut contenir que deux fois l'instruction if.
# ------------------------------------------------------------
# Méthode de résolution
# On établit une table de vérité T|L|M->R|V|B (T: température, L: luminosité, M: son)
# Seule l'équation de R peut être simplifiée avec un tableau de Karnaught
# ------------------------------------------------------------
from quickpi import *
while True:
# V = TLM
    if readTemperature("thermometer1") >= 16 and readTemperature("thermometer1") <= 18 and readLightIntensity("light1") <= 10 and readSoundLevel("mic1") <= 20:
        setLedState("red1", False)
        setLedState("green1", True)
        setLedState("blue1", False)
# R = /L/M + /T(/L+/M)
    elif readLightIntensity("light1") > 10 and readSoundLevel("mic1") > 20 or (readTemperature("thermometer1") < 16 or readTemperature("thermometer1") > 18)and(readLightIntensity("light1") > 10 or readSoundLevel("mic1") > 20):
        setLedState("red1", True)
        setLedState("green1", False)
        setLedState("blue1", False)
# B = /TLM + T/LM + TL/M
    else:
        setLedState("red1", False)
        setLedState("green1", False)
        setLedState("blue1", True)
